#include <Adafruit_GFX.h>
#include <SPI.h>
#include <Wire.h>
#include <Adafruit_ILI9341.h>
#include <Adafruit_STMPE610.h>

// This is calibration data for the raw touch data to the screen coordinates
#define TS_MINX 150
#define TS_MINY 130
#define TS_MAXX 3800
#define TS_MAXY 4000

#define STMPE_CS 8
Adafruit_STMPE610 ts = Adafruit_STMPE610(STMPE_CS);
#define TFT_CS 10
#define TFT_DC 9
Adafruit_ILI9341 tft = Adafruit_ILI9341(TFT_CS, TFT_DC);

#define BOXSIZE 50
int oldcolor, currentcolor;
boolean RecordOn = false;
int x = 0;


void setup(void)
{
  Serial.begin(9600);
  tft.begin();
  if (!ts.begin()) { 
    
    Serial.println("Unable to start touchscreen.");
    delay(2000);
  } 
  else { 
    
    Serial.println("Touchscreen started."); 
    delay(2000);
  }

  tft.fillScreen(ILI9341_WHITE);
  Serial.println("WHITE");
  delay(2000);
  
  
  tft.fillRect(12, 14, BOXSIZE, BOXSIZE, ILI9341_RED);
  tft.fillRect(12, 25+BOXSIZE, BOXSIZE, BOXSIZE, ILI9341_YELLOW);
  tft.fillRect(12, 35+BOXSIZE*2, BOXSIZE, BOXSIZE, ILI9341_GREEN);
  tft.fillRect(12, 45+BOXSIZE*3, BOXSIZE, BOXSIZE, ILI9341_CYAN);
  tft.fillRect(12, 55+BOXSIZE*4, BOXSIZE, BOXSIZE, ILI9341_BLUE);
  tft.fillRect(74, 35+BOXSIZE*2, BOXSIZE, BOXSIZE, ILI9341_MAGENTA);
  

}

void loop()
{
  // See if there's any  touch data for us
  //if (ts.bufferEmpty()) {
   // return;
  //}
  
  // You can also wait for a touch
  if (! ts.touched()) {
    return;
  }
  

  // Retrieve a point  
  TS_Point p = ts.getPoint();
  
 
 // Serial.print("X = "); Serial.print(p.x);
  //Serial.print("\tY = "); Serial.print(p.y);
  //Serial.print("\tPressure = "); Serial.println(p.z);  
 
 
  // Scale from ~0->4000 to tft.width using the calibration #'s
  p.x = map(p.x, TS_MINX, TS_MAXX, 0, tft.width());
  p.y = map(p.y, TS_MINY, TS_MAXY, 0, tft.height());

 
 // Serial.print("("); Serial.print(p.x);
 // Serial.print(", "); Serial.print(p.y);
  //Serial.println(")");
  

  if (p.x >= 20 && p.x <= 70) {
     oldcolor = currentcolor;
 Serial.print("("); Serial.print(p.x);
  Serial.print(", "); Serial.print(p.y);
  Serial.println(")");
     if (p.y >= 15 && p.y <= 62) { 
       currentcolor = ILI9341_RED; 
       tft.drawRect(12, 14, BOXSIZE, BOXSIZE, ILI9341_BLACK);
     } else if (p.y >= 77 && p.y <= 116) {
       currentcolor = ILI9341_YELLOW;
       tft.drawRect(12, 25+BOXSIZE, BOXSIZE, BOXSIZE, ILI9341_BLACK);
     } else if (p.y >= 125 && p.y <= 170) {
       currentcolor = ILI9341_GREEN;
       tft.drawRect(12, 35+BOXSIZE*2, BOXSIZE, BOXSIZE, ILI9341_BLACK);
     } else if (p.y >= 182 && p.y <= 230) {
       currentcolor = ILI9341_CYAN;
       tft.drawRect(12, 45+BOXSIZE*3, BOXSIZE, BOXSIZE, ILI9341_BLACK);
     } else if (p.y >= 242 && p.y <= 292) {
       currentcolor = ILI9341_BLUE;
       tft.drawRect(12, 55+BOXSIZE*4, BOXSIZE, BOXSIZE, ILI9341_BLACK);
     } 
  }else if (p.x >= 82 && p.x <= 132) {
    Serial.println("secondrow"); 
    Serial.print("("); Serial.print(p.x);
    Serial.print(", "); Serial.print(p.y);
    Serial.println(")");
    oldcolor = currentcolor;
    if (p.y >= 125 && p.y <= 170) {
       currentcolor = ILI9341_MAGENTA;
         tft.drawRect(74, 35+BOXSIZE*2, BOXSIZE, BOXSIZE, ILI9341_BLACK);
    }
   }
       
    if (oldcolor != currentcolor) {
        if (oldcolor == ILI9341_RED) 
          tft.fillRect(12, 14, BOXSIZE, BOXSIZE, ILI9341_RED);
        if (oldcolor == ILI9341_YELLOW) 
          tft.fillRect(12, 25+BOXSIZE, BOXSIZE, BOXSIZE, ILI9341_YELLOW);
        if (oldcolor == ILI9341_GREEN) 
          tft.fillRect(12, 35+BOXSIZE*2, BOXSIZE, BOXSIZE, ILI9341_GREEN);
        if (oldcolor == ILI9341_CYAN) 
          tft.fillRect(12, 45+BOXSIZE*3, BOXSIZE, BOXSIZE, ILI9341_CYAN);
        if (oldcolor == ILI9341_BLUE) 
          tft.fillRect(12, 55+BOXSIZE*4, BOXSIZE, BOXSIZE, ILI9341_BLUE);
        if (oldcolor == ILI9341_MAGENTA) 
          tft.fillRect(74, 35+BOXSIZE*2, BOXSIZE, BOXSIZE, ILI9341_MAGENTA);
    }
  
 
}
